//+------------------------------------------------------------------+
//|                                                     #BoraEx1.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#define MAGICMA  123456

//   
extern double Lots=0.1;                 //  
extern int LossCount=2;                 //     
extern double MultLots=2;               //       
extern int ChangeDirection=0;           //     (0- , 1- )
extern int SL=100;                      //  
extern int Trailing=100;                //  
extern int TP=50;

int Ticket1, Ticket2;

int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)
         {
          buys++;
          Ticket1=OrderTicket();
         } 
         if(OrderType()==OP_SELL)
         {
          sells++;
          Ticket1=OrderTicket();
         } 
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }  

int CalculateLimitOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
         {
          buys++;
          Ticket2=OrderTicket();
         } 
         if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
         {
          sells++;
          Ticket2=OrderTicket();
         } 
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }  



int init()
  {

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
  {
   int res;
   if (CalculateCurrentOrders(Symbol())==0 && CalculateLimitOrders(Symbol())==0)
   //  
   {
    res=OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid-SL*Point, Bid+TP*Point, NULL, MAGICMA, 0);
    if (LossCount>1)
    {
     res=OrderSend(Symbol(), OP_BUYLIMIT, Lots*MultLots, Ask-SL*Point, 3, Bid-2*SL*Point, Bid-(SL-TP)*Point, NULL, MAGICMA, 0);
    }
    else
    {
     res=OrderSend(Symbol(), OP_SELLSTOP, Lots*MultLots, Bid-SL*Point, 3, Ask, Ask-(SL+TP)*Point, NULL, MAGICMA, 0);
    } 
   }
   
   if (CalculateCurrentOrders(Symbol())!=0 && CalculateLimitOrders(Symbol())!=0)
   // 
   {
    if(OrderSelect(Ticket1,SELECT_BY_TICKET,MODE_TRADES))
    {
     if(OrderType()==OP_BUY)
     {
      if (Ask!=OrderOpenPrice() && Bid-OrderStopLoss()>(Trailing+1)*Point)
      {
       res=OrderModify(OrderTicket(),0,Bid-Trailing*Point,OrderTakeProfit(),0);
       if (Bid-Trailing*Point>OrderOpenPrice())
       {
       //     
        if(OrderSelect(Ticket2,SELECT_BY_TICKET,MODE_TRADES))
        {
         if (OrderLots()!=Lots)
         {
          OrderDelete(Ticket2);
          if (ChangeDirection==1)
          {
           res=OrderSend(Symbol(), OP_SELLSTOP, Lots, Bid-Trailing*Point, 3, Ask-(Trailing-SL)*Point, Ask-(Trailing+TP)*Point, NULL, MAGICMA, 0);
          }
          else
          {
           res=OrderSend(Symbol(), OP_BUYLIMIT, Lots, Ask-Trailing*Point, 3, Bid-(Trailing+SL)*Point, Bid-(Trailing-TP)*Point, NULL, MAGICMA, 0);
          }
         } 
        }
       }
       {
        if(OrderSelect(Ticket2,SELECT_BY_TICKET,MODE_TRADES))
        {
         if (OrderType()==OP_BUYLIMIT)
         {
          OrderModify(OrderTicket(),Ask-Trailing*Point,Bid-(Trailing+SL)*Point,OrderTakeProfit(),0);        
         }
         if (OrderType()==OP_SELLSTOP)
         {
          OrderModify(OrderTicket(),Bid-Trailing*Point,Ask-(Trailing-SL)*Point,OrderTakeProfit(),0);        
         }
         
        } 
       }
      }
     }
     if(OrderType()==OP_SELL)
     {
      if (Bid!=OrderOpenPrice() && OrderStopLoss()-Ask>(Trailing+1)*Point)
      {
       res=OrderModify(OrderTicket(),0,Ask+Trailing*Point,OrderTakeProfit(),0);
       if (Trailing*Point+Ask<OrderOpenPrice())
       {
       //     
        if(OrderSelect(Ticket2,SELECT_BY_TICKET,MODE_TRADES))
        {
         if (OrderLots()!=Lots)
         {
          OrderDelete(Ticket2);
          if (ChangeDirection==0)
          {
           res=OrderSend(Symbol(), OP_BUYSTOP, Lots, Ask+Trailing*Point, 3, Bid+(Trailing-SL)*Point, Bid+(Trailing+TP)*Point, NULL, MAGICMA, 0);
          }
          else
          {
           res=OrderSend(Symbol(), OP_SELLLIMIT, Lots, Bid+Trailing*Point, 3, Bid+(Trailing+SL)*Point, Bid+(Trailing-TP)*Point, NULL, MAGICMA, 0);
          }
         } 
        }
       }
       {
        if(OrderSelect(Ticket2,SELECT_BY_TICKET,MODE_TRADES))
        {
         if (OrderType()==OP_BUYSTOP)
         {
          OrderModify(OrderTicket(),Ask+Trailing*Point,Bid+(Trailing-SL)*Point,OrderTakeProfit(),0);        
         }
         if (OrderType()==OP_SELLLIMIT)
         {
          OrderModify(OrderTicket(),Bid+Trailing*Point,Ask+(Trailing+SL)*Point,OrderTakeProfit(),0);        
         } 
        } 
       }
      }
     }
    }
   }
   
   if (CalculateCurrentOrders(Symbol())!=0 && CalculateLimitOrders(Symbol())==0)
   //   
   {
    if(OrderSelect(Ticket1,SELECT_BY_TICKET,MODE_TRADES))
    {
     double L=OrderLots();
     int Coeff=MathRound(MathLog(L/Lots)/MathLog(MultLots));
     bool A;
     if (MathFloor((Coeff+0.)/(LossCount-1.))==(Coeff+0.)/(LossCount-1.)) A=true; else A=false;
     
     if (OrderType()==OP_BUY)
     {
      if (A)
      {
       res=OrderSend(Symbol(), OP_SELLSTOP, OrderLots()*MultLots, OrderStopLoss(), 3, OrderStopLoss()+SL*Point+Ask-Bid, OrderStopLoss()-TP*Point+Ask-Bid, NULL, MAGICMA, 0);
      }
      else
      {
       res=OrderSend(Symbol(), OP_BUYLIMIT, OrderLots()*MultLots, OrderStopLoss()+Ask-Bid, 3, OrderStopLoss()-SL*Point, OrderStopLoss()+TP*Point, NULL, MAGICMA, 0);
      }
     }
     
     if (OrderType()==OP_SELL)
     {
      if (A)
      {
       res=OrderSend(Symbol(), OP_BUYSTOP, OrderLots()*MultLots, OrderStopLoss()+Ask-Bid, 3, OrderStopLoss()-SL*Point, OrderStopLoss()+TP*Point, NULL, MAGICMA, 0);
      }
      else
      {
       res=OrderSend(Symbol(), OP_SELLLIMIT, OrderLots()*MultLots, OrderStopLoss(), 3, OrderStopLoss()+SL*Point+Ask-Bid, OrderStopLoss()-TP*Point+Ask-Bid, NULL, MAGICMA, 0);
      }
     }
     
    }
   }

   return(0);
  }


